-- BEGIN COPYRIGHT
-- *************************************************************************
--
--  Licensed Materials - Property of IBM
--  5725-C94, 5725-C95, 5725-C96
--  (C) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
--  US Government Users Restricted Rights- Use, duplication or disclosure
--  restricted by GSA ADP Schedule Contract with IBM Corp.
--
-- *************************************************************************
-- END COPYRIGHT


SET CURRENT SCHEMA = '@SCHEMA@';
        
     
    

      
-- START of phase ProcUpgradeTo855 --
        
       
ALTER  TABLE @SCHEMA@.BPM_COACH_VIEW 
ADD 
    "PREVIEW_ADV_HTML" CHAR(36)
;

ALTER  TABLE @SCHEMA@.BPM_COACH_VIEW 
ADD 
    "PREVIEW_ADV_JS" CHAR(36)
;



ALTER  TABLE @SCHEMA@.BPM_COACH_VIEW_RESOURCE 
ADD 
    "SCRIPT_LOAD_STYLE" VARCHAR(128)
;


ALTER  TABLE @SCHEMA@.LSW_BPD 
ADD 
    "OWNER_TEAM_PARTICIPANT_REF" CHAR(36)
;

ALTER  TABLE @SCHEMA@.LSW_BPD 
ADD 
    "BPMN2_DATA" BLOB(2G)
;

CREATE LOB TABLESPACE WLP10426
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_BPD28_LOB
    IN @DB_NAME@.WLP10426
    STORES @SCHEMA@.LSW_BPD COLUMN BPMN2_DATA
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_BPD28_I
    ON @SCHEMA@.LSW_BPD28_LOB
    USING STOGROUP @STOGRP@
;
        
ALTER  TABLE @SCHEMA@.LSW_BPD 
ADD 
    "DEPENDENCY_SUMMARY" CLOB(2G)
;

CREATE LOB TABLESPACE WLP10428
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_BPD29_LOB
    IN @DB_NAME@.WLP10428
    STORES @SCHEMA@.LSW_BPD COLUMN DEPENDENCY_SUMMARY
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_BPD29_I
    ON @SCHEMA@.LSW_BPD29_LOB
    USING STOGROUP @STOGRP@
;
        
ALTER  TABLE @SCHEMA@.LSW_BPD 
ADD 
    "INTERNAL_NAME" VARCHAR(200)
;





ALTER  TABLE @SCHEMA@.LSW_BPD_INSTANCE 
ADD 
    "CASE_FOLDER_ID" VARCHAR(80)
;

ALTER  TABLE @SCHEMA@.LSW_BPD_INSTANCE 
ADD 
    "STARTING_DOCUMENT_ID" VARCHAR(80)
;

ALTER  TABLE @SCHEMA@.LSW_BPD_INSTANCE 
ADD 
    "OWNER_GROUP_ID" DECIMAL(12,0)
;

ALTER  TABLE @SCHEMA@.LSW_BPD_INSTANCE 
ADD 
    "DOCUMENTS_STATE" DECIMAL(1,0)
        DEFAULT 0 NOT NULL
;





CREATE INDEX @SCHEMA@.LSWC_CASE_FOLDER_ID_NUQ 
    ON @SCHEMA@.LSW_BPD_INSTANCE(
    "CASE_FOLDER_ID")
    USING STOGROUP @STOGRP@

;

CREATE TABLESPACE WLPT220
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.BPM_TWCLASS_EXTENSION (
    "EXTENSION_ID" CHAR(36) NOT NULL,
    "CLASS_ID" CHAR(36) NOT NULL,
    "XML_DATA" BLOB(2G),
    "GUID" VARCHAR(256) NOT NULL,
    "VERSION_ID" CHAR(36) NOT NULL,
    "LAST_MODIFIED" TIMESTAMP NOT NULL,
    "LAST_MODIFIED_BY_USER_ID" DECIMAL(12,0) NOT NULL
)
IN @DB_NAME@.WLPT220
;

CREATE LOB TABLESPACE WLP753
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.BPM_TWCLASS_EXTENSION3_LOB
    IN @DB_NAME@.WLP753
    STORES @SCHEMA@.BPM_TWCLASS_EXTENSION COLUMN XML_DATA
;
CREATE UNIQUE INDEX @SCHEMA@.BPM_TWCLASS_EXTENSION3_I
    ON @SCHEMA@.BPM_TWCLASS_EXTENSION3_LOB
    USING STOGROUP @STOGRP@
;
        

CREATE UNIQUE INDEX @SCHEMA@.BPM_TWCLASS_EXTENSION_PK
    ON @SCHEMA@.BPM_TWCLASS_EXTENSION
    ("VERSION_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.BPM_TWCLASS_EXTENSION
    ADD CONSTRAINT BPM_TWCLASS_EXTENSION_PK
    PRIMARY KEY(
       "VERSION_ID")

;

CREATE INDEX @SCHEMA@.BPM_TWCLASS_EXTENSION_PK3
    ON @SCHEMA@.BPM_TWCLASS_EXTENSION("GUID")
    USING STOGROUP @STOGRP@

;

CREATE TABLESPACE WLPZ5104
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE (
    "INSTANCE_ID" CHAR(36) NOT NULL,
    "BPD_FLOW_OBJECT_ID" VARCHAR(256) NOT NULL,
    "PARENT_NODE_ID" DECIMAL(12,0) NOT NULL,
    "BPD_INSTANCE_ID" DECIMAL(12,0) NOT NULL,
    "NAME" VARCHAR(256) NOT NULL,
    "EXECUTION_STATE" DECIMAL(12,0) NOT NULL,
    "TASK_TYPE" DECIMAL(12,0) NOT NULL,
    "TASK_ID" DECIMAL(12,0),
    "REQUIRED" CHAR(1) NOT NULL,
    "REPEATABLE" CHAR(1) NOT NULL,
    "HIDDEN" CHAR(1) NOT NULL,
    "EXECUTION_TYPE" DECIMAL(12,0) NOT NULL,
    "OPTION_TYPE" DECIMAL(12,0) NOT NULL,
    "PRECONDITION_TYPE" DECIMAL(12,0) NOT NULL,
    "OWNER_GROUP_ID" DECIMAL(12,0),
    "START_DATE" TIMESTAMP,
    "END_DATE" TIMESTAMP,
    "LAST_MODIFIED_DATETIME" TIMESTAMP NOT NULL,
    "ENABLING_DOCUMENT_ID" VARCHAR(80),
    "EVALUATED_NARRATIVES" BLOB(2G),
    "ERRORS" BLOB(2G)
)
IN @DB_NAME@.WLPZ5104
;

CREATE LOB TABLESPACE WLPZ5105
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE_LOB
    IN @DB_NAME@.WLPZ5105
    STORES @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE COLUMN EVALUATED_NARRATIVES
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE_I
    ON @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE_LOB
    USING STOGROUP @STOGRP@
;
        
CREATE LOB TABLESPACE WLPZ5110
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE2_LOB
    IN @DB_NAME@.WLPZ5110
    STORES @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE COLUMN ERRORS
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE2_I
    ON @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE2_LOB
    USING STOGROUP @STOGRP@
;
        

CREATE UNIQUE INDEX @SCHEMA@.LSWC_BPD_ACTIVITY_INSTANCE_PK
    ON @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE
    ("INSTANCE_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE
    ADD CONSTRAINT LSWC_BPD_ACTIVITY_INSTANCE_PK
    PRIMARY KEY(
       "INSTANCE_ID")

;

CREATE INDEX @SCHEMA@.LSWC_BPD_ACTIVITY_INSTANCE_PK4
    ON @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE("NAME")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.IDX01_BPD_ACTIVITY_INST 
    ON @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE(
    "BPD_INSTANCE_ID",
    "OPTION_TYPE",
    "REQUIRED",
    "PARENT_NODE_ID",
    "EXECUTION_STATE")
    USING STOGROUP @STOGRP@

;

CREATE TABLESPACE WLPT221
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.BPM_BPD_EVENT (
    "BPM_EVENT_ID" CHAR(36) NOT NULL,
    "CORRELATION_PATH" VARCHAR(256),
    "CORRELATION_VALUE" VARCHAR(256) NOT NULL,
    "ADDITIONAL_DATA" CLOB(2G),
    "BPD_ID" CHAR(36) NOT NULL,
    "BPD_FLOW_OBJECT_ID" VARCHAR(256) NOT NULL,
    "EVENT_TYPE" DECIMAL(2,0) NOT NULL,
    "CORRELATION_TYPE" DECIMAL(2,0) NOT NULL,
    "VERSION_ID" CHAR(36) NOT NULL
)
IN @DB_NAME@.WLPT221
;

CREATE LOB TABLESPACE WLP10427
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.BPM_BPD_EVENT4_LOB
    IN @DB_NAME@.WLP10427
    STORES @SCHEMA@.BPM_BPD_EVENT COLUMN ADDITIONAL_DATA
;
CREATE UNIQUE INDEX @SCHEMA@.BPM_BPD_EVENT4_I
    ON @SCHEMA@.BPM_BPD_EVENT4_LOB
    USING STOGROUP @STOGRP@
;
        

CREATE UNIQUE INDEX @SCHEMA@.LSWC_BPM_BPD_EVENT_PK
    ON @SCHEMA@.BPM_BPD_EVENT
    ("VERSION_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.BPM_BPD_EVENT
    ADD CONSTRAINT LSWC_BPM_BPD_EVENT_PK
    PRIMARY KEY(
       "VERSION_ID")

;

CREATE INDEX @SCHEMA@.LSWC_BPM_BPD_EVENT_NUQ1 
    ON @SCHEMA@.BPM_BPD_EVENT(
    "BPM_EVENT_ID")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.LSWC_BPM_BPD_EVENT_NUQ2 
    ON @SCHEMA@.BPM_BPD_EVENT(
    "BPD_ID")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.LSWC_BPM_BPD_EVENT_NUQ3 
    ON @SCHEMA@.BPM_BPD_EVENT(
    "BPD_FLOW_OBJECT_ID")
    USING STOGROUP @STOGRP@

;
DROP INDEX @SCHEMA@.LSWC_GXREF_NU
;


CREATE INDEX @SCHEMA@.LSWC_GXREF_NU2 
    ON @SCHEMA@.LSW_USR_GRP_XREF(
    "GROUP_TYPE",
    "GROUP_ID")
    USING STOGROUP @STOGRP@

;

DROP PROCEDURE @SCHEMA@.LSW_ERASE_TEMP_GROUPS@
                
CREATE PROCEDURE @SCHEMA@.LSW_ERASE_TEMP_GROUPS()

  -- This procedure deletes all temporary groups that are no --
  -- longer referenced by a task. --

MAIN:
  BEGIN

    DECLARE groupId DECIMAL(12,0);
    DECLARE sqlCmd VARCHAR(500);
    DECLARE at_end DECIMAL(1,0);
    DECLARE not_found CONDITION for SQLSTATE '02000';
    DECLARE CONTINUE HANDLER for not_found SET at_end = 1;

    BEGIN
        DECLARE groupsToDelete CURSOR FOR stmt1;
        
        SET sqlCmd = 'SELECT DISTINCT G.GROUP_ID ' ||
                     'FROM @SCHEMA@.LSW_USR_GRP_XREF G ' ||
                     'WHERE G. GROUP_TYPE = 2 AND NOT EXISTS ' ||
                     '( SELECT T.GROUP_ID FROM @SCHEMA@.LSW_TASK T WHERE T.GROUP_ID = G.GROUP_ID ' ||
                     'UNION ALL SELECT T.GROUP_ID FROM @SCHEMA@.LSW_TASK T WHERE T.GROUP_ID = - G.GROUP_ID )';
        PREPARE stmt1 FROM sqlCmd;
        
        OPEN groupsToDelete;
        DELETE_GROUP_LOOP:
        LOOP
            SET at_end = 0;
            FETCH groupsToDelete INTO groupId;
            IF (at_end = 1) THEN
                LEAVE DELETE_GROUP_LOOP;
            END IF;
            
            DELETE FROM @SCHEMA@.LSW_USR_GRP_MEM_XREF WHERE GROUP_ID = groupId;
            DELETE FROM @SCHEMA@.LSW_GRP_GRP_MEM_EXPLODED_XREF WHERE GROUP_ID = groupId OR CONTAINER_GROUP_ID = groupId;
            DELETE FROM @SCHEMA@.LSW_GRP_GRP_MEM_XREF WHERE GROUP_ID = groupId OR CONTAINER_GROUP_ID = groupId;
            DELETE FROM @SCHEMA@.LSW_USR_GRP_XREF WHERE GROUP_ID = groupId;
            
        END LOOP;
        CLOSE groupsToDelete;
    END;
    
  END@
                
ALTER  TABLE @SCHEMA@.BPM_COACH_VIEW_CONFIG_OPTION 
ADD 
    "IS_ADAPTIVE" CHAR(1)
        DEFAULT 'F'
;


CREATE TABLESPACE WLPZ5106
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION (
    "CORRELATION_PK" DECIMAL(12,0) NOT NULL,
    "BPD_ID" CHAR(36) NOT NULL,
    "BPD_INSTANCE_ID" DECIMAL(12,0) NOT NULL,
    "CORRELATION_NAME" VARCHAR(1024) NOT NULL,
    "CORRELATION_VALUE" CLOB(2G) NOT NULL,
    "HASH_CODE" CHAR(32) NOT NULL
)
IN @DB_NAME@.WLPZ5106
;

CREATE LOB TABLESPACE WLPZ5107
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION_LOB
    IN @DB_NAME@.WLPZ5107
    STORES @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION COLUMN CORRELATION_VALUE
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION_I
    ON @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION_LOB
    USING STOGROUP @STOGRP@
;
        

CREATE UNIQUE INDEX @SCHEMA@.LSWC_BPD_INST_COR_PK
    ON @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION
    ("CORRELATION_PK")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION
    ADD CONSTRAINT LSWC_BPD_INST_COR_PK
    PRIMARY KEY(
       "CORRELATION_PK")

;

CREATE UNIQUE INDEX @SCHEMA@.LSWC_BPD_INST_COR_UK
    ON @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION(
        "BPD_ID",
        "CORRELATION_NAME",
        "HASH_CODE")
    USING STOGROUP @STOGRP@

;

CREATE TABLESPACE WLPZ5108
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA (
    "BPD_EXTENDED_DATA_ID" DECIMAL(12,0) NOT NULL,
    "BPD_INSTANCE_ID" DECIMAL(12,0) NOT NULL,
    "DATA" BLOB(2G),
    "TYPE" DECIMAL(2,0) NOT NULL
)
IN @DB_NAME@.WLPZ5108
;

CREATE LOB TABLESPACE WLPZ5109
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA_LOB
    IN @DB_NAME@.WLPZ5109
    STORES @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA COLUMN DATA
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA_I
    ON @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA_LOB
    USING STOGROUP @STOGRP@
;
        

CREATE UNIQUE INDEX @SCHEMA@.LSWC_BPD_INST_EXT_DATA_PK
    ON @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA
    ("BPD_EXTENDED_DATA_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA
    ADD CONSTRAINT LSWC_BPD_INST_EXT_DATA_PK
    PRIMARY KEY(
       "BPD_EXTENDED_DATA_ID")

;

CREATE INDEX @SCHEMA@.LSWC_BPD_INST_EXT_DATA_NU 
    ON @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA(
    "BPD_INSTANCE_ID")
    USING STOGROUP @STOGRP@

;

DROP PROCEDURE @SCHEMA@.LSW_ERASE_BPD_INST_NO_GROUP@
                
CREATE PROCEDURE @SCHEMA@.LSW_ERASE_BPD_INST_NO_GROUP(
    IN bpdInstanceId DECIMAL(12,0))
    LANGUAGE SQL

MAIN:
  BEGIN

    DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE_DOC_PROPS
     WHERE DOC_ID IN (SELECT DOC_ID FROM @SCHEMA@.LSW_BPD_INSTANCE_DOCUMENTS
                       WHERE BPD_INSTANCE_ID = bpdInstanceId);

    DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE_DOCUMENTS
     WHERE BPD_INSTANCE_ID = bpdInstanceId;
   
    DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE_VARIABLES
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE_DATA
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE_CORRELATION
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

   DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE_EXT_DATA
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_BPD_NOTIFICATION
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_RUNTIME_ERROR
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_BPD_INSTANCE
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_INST_MSG_INCL
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

    DELETE FROM @SCHEMA@.LSW_INST_MSG_EXCL
     WHERE BPD_INSTANCE_ID = bpdInstanceId;
     
    DELETE FROM @SCHEMA@.LSW_BPD_ACTIVITY_INSTANCE
     WHERE BPD_INSTANCE_ID = bpdInstanceId;

  END@
                

CREATE INDEX @SCHEMA@.LSWC_TASK_NARR_NU 
    ON @SCHEMA@.LSW_TASK_NARR(
    "TASK_ID")
    USING STOGROUP @STOGRP@

;


CREATE INDEX @SCHEMA@.LSWC_TASK_ADDR_NU 
    ON @SCHEMA@.LSW_TASK_ADDR(
    "TASK_ID")
    USING STOGROUP @STOGRP@

;


CREATE INDEX @SCHEMA@.LSWC_TASK_FILE_NU 
    ON @SCHEMA@.LSW_TASK_FILE(
    "TASK_ID")
    USING STOGROUP @STOGRP@

;

DROP TABLE @SCHEMA@.BPM_ASSET_CACHE_STATUS;
COMMIT;

CREATE TABLE @SCHEMA@.BPM_ASSET_CACHE_STATUS (
    "ASSET_ID" VARCHAR(60) NOT NULL,
    "CONTAINER_ID" CHAR(36) NOT NULL,
    "SESSION_ID" VARCHAR(36),
    "CLIENT_ID" VARCHAR(36),
    "LATEST_SNAPSHOT_ID" VARCHAR(100),
    "VERSION_ID" CHAR(36),
    "L_MODEL_BATCH_NO_IN_SS" DECIMAL(19,0)
        DEFAULT 0,
    "L_MODEL_BATCH_NO" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "L_RN_TAG_BATCH_NO_IN_SS" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "L_RN_TAG_BATCH_NO" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "COMMITTED_MODEL_BATCH_NO" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "LATEST_BATCH_NO" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "LATEST_COMMIT_SEQ" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "L_SUMMARY_COMMIT_SEQ" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "CORRUPTED_BATCH_NO" DECIMAL(19,0),
    "ASSET_TYPE" VARCHAR(128),
    "USER_ID" VARCHAR(200) NOT NULL,
    "LOCK_STATUS" CHAR(1)
        DEFAULT 'F',
    "LOCKED_ON" TIMESTAMP,
    "LAST_MODIFIED_ON" TIMESTAMP NOT NULL,
    "FIELD1" VARCHAR(128),
    "FIELD2" VARCHAR(128),
    "FIELD3" DECIMAL(19,0)
)
IN @DB_NAME@.WLPZ7801
;
CREATE UNIQUE INDEX @SCHEMA@.BPM_ASSET_CACHE_STS_PK
    ON @SCHEMA@.BPM_ASSET_CACHE_STATUS
    ("CONTAINER_ID","ASSET_ID")
    USING STOGROUP @STOGRP@
;
ALTER TABLE @SCHEMA@.BPM_ASSET_CACHE_STATUS
    ADD CONSTRAINT BPM_ASSET_CACHE_STS_PK
    PRIMARY KEY(
       "CONTAINER_ID",
       "ASSET_ID")
;
CREATE INDEX @SCHEMA@.BPM_ASSET_CACHE_STS_IDX1 
    ON @SCHEMA@.BPM_ASSET_CACHE_STATUS(
    "CLIENT_ID")
    USING STOGROUP @STOGRP@
;
CREATE INDEX @SCHEMA@.BPM_ASSET_CACHE_STS_IDX2 
    ON @SCHEMA@.BPM_ASSET_CACHE_STATUS(
    "CONTAINER_ID",
    "L_RN_TAG_BATCH_NO",
    "L_RN_TAG_BATCH_NO_IN_SS",
    "COMMITTED_MODEL_BATCH_NO",
    "L_MODEL_BATCH_NO_IN_SS")
    USING STOGROUP @STOGRP@
;
                
                    DROP INDEX @SCHEMA@.BPM_ASSET_SAVE_INSTR_IDX1
                
;

                    DROP INDEX @SCHEMA@.BPM_ASSET_SAVE_INSTR_IDX3
                
;

ALTER  TABLE @SCHEMA@.BPM_ASSET_CACHE_SAVE_INSTR 
ADD 
    "COMMIT_SEQ" DECIMAL(19,0)
;

ALTER  TABLE @SCHEMA@.BPM_ASSET_CACHE_SAVE_INSTR 
ADD 
    "RN_TAG" CHAR(1)
        DEFAULT 'F'
;

ALTER  TABLE @SCHEMA@.BPM_ASSET_CACHE_SAVE_INSTR_BK 
ADD 
    "COMMIT_SEQ" DECIMAL(19,0)
;

ALTER  TABLE @SCHEMA@.BPM_ASSET_CACHE_SAVE_INSTR_BK 
ADD 
    "RN_TAG" CHAR(1)
        DEFAULT 'F'
;

CREATE TABLESPACE WLPZ7811
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE16K@
;
CREATE TABLE @SCHEMA@.BPM_ASSET_CACHE_INSTR_DISCARD (
    "ASSET_ID" VARCHAR(60) NOT NULL,
    "ROOT_ID" VARCHAR(60) NOT NULL,
    "CONTAINER_ID" CHAR(36) NOT NULL,
    "BATCH_NO" DECIMAL(19,0) NOT NULL,
    "DATA_SEQ" DECIMAL(3,0) NOT NULL,
    "DATA" VARCHAR(8000),
    "COMMIT_SEQ" DECIMAL(19,0),
    "SNAPSHOT_ID" VARCHAR(100),
    "SNAPSHOT_SEQ" DECIMAL(19,0)
        DEFAULT 0,
    "USER_ID" VARCHAR(200) NOT NULL,
    "PENDING_SUMMARY" CHAR(1)
        DEFAULT 'F',
    "RN_TAG" CHAR(1)
        DEFAULT 'F',
    "BAD_BATCH" CHAR(1)
        DEFAULT 'F',
    "MODIFIED_ON" TIMESTAMP NOT NULL,
    "BASE_BATCH_NO" DECIMAL(19,0),
    "DISCARD_GUID" CHAR(36),
    "CLIENT_ID" VARCHAR(36),
    "FIELD1" VARCHAR(128),
    "FIELD2" VARCHAR(128),
    "FIELD3" DECIMAL(19,0)
)
IN @DB_NAME@.WLPZ7811
;

CREATE TABLESPACE WLPZ7812
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE16K@
;
CREATE TABLE @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG (
    "CONTAINER_ID" CHAR(36) NOT NULL,
    "SNAPSHOT_ID" VARCHAR(100) NOT NULL,
    "SNAPSHOT_SEQ" DECIMAL(19,0)
        DEFAULT 0 NOT NULL,
    "FROM_EDIT_CACHE" CHAR(1)
        DEFAULT 'F' NOT NULL,
    "STATUS" DECIMAL(1,0) NOT NULL,
    "DATA" VARCHAR(8000),
    "LOB_DATA" CLOB(2G),
    "CACHED_ON" TIMESTAMP NOT NULL,
    "FIELD1" VARCHAR(128),
    "FIELD2" VARCHAR(128),
    "FIELD3" DECIMAL(19,0)
)
IN @DB_NAME@.WLPZ7812
;

CREATE LOB TABLESPACE WLPZ7813
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG_LOB
    IN @DB_NAME@.WLPZ7813
    STORES @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG COLUMN LOB_DATA
;
CREATE UNIQUE INDEX @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG_I
    ON @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG_LOB
    USING STOGROUP @STOGRP@
;
        






CREATE UNIQUE INDEX @SCHEMA@.BPM_ASSET_INSTR_DIS_PK
    ON @SCHEMA@.BPM_ASSET_CACHE_INSTR_DISCARD
    ("CONTAINER_ID","ASSET_ID","BATCH_NO","DATA_SEQ")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.BPM_ASSET_CACHE_INSTR_DISCARD
    ADD CONSTRAINT BPM_ASSET_INSTR_DIS_PK
    PRIMARY KEY(
       "CONTAINER_ID",
       "ASSET_ID",
       "BATCH_NO",
       "DATA_SEQ")

;


CREATE UNIQUE INDEX @SCHEMA@.BPM_ASSET_CACHE_E_MSG_PK
    ON @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG
    ("CONTAINER_ID","SNAPSHOT_SEQ")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG
    ADD CONSTRAINT BPM_ASSET_CACHE_E_MSG_PK
    PRIMARY KEY(
       "CONTAINER_ID",
       "SNAPSHOT_SEQ")

;

CREATE INDEX @SCHEMA@.BPM_ASSET_SAVE_INSTR_IDX1 
    ON @SCHEMA@.BPM_ASSET_CACHE_SAVE_INSTR(
    "CONTAINER_ID",
    "ROOT_ID",
    "COMMIT_SEQ",
    "ASSET_ID",
    "BATCH_NO",
    "DATA_SEQ")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_ASSET_SAVE_INSTR_IDX3 
    ON @SCHEMA@.BPM_ASSET_CACHE_SAVE_INSTR(
    "CONTAINER_ID",
    "PENDING_SUMMARY",
    "COMMIT_SEQ",
    "ASSET_ID",
    "BATCH_NO",
    "DATA_SEQ",
    "SNAPSHOT_SEQ")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_ASSET_INSTR_DIS_IDX1 
    ON @SCHEMA@.BPM_ASSET_CACHE_INSTR_DISCARD(
    "CONTAINER_ID",
    "ROOT_ID",
    "BATCH_NO")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_ASSET_INSTR_DIS_IDX2 
    ON @SCHEMA@.BPM_ASSET_CACHE_INSTR_DISCARD(
    "MODIFIED_ON")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_ASSET_INSTR_DIS_IDX3 
    ON @SCHEMA@.BPM_ASSET_CACHE_INSTR_DISCARD(
    "DISCARD_GUID")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_ASSET_CACHE_E_MSG_IDX1 
    ON @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG(
    "CONTAINER_ID",
    "STATUS")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_ASSET_CACHE_E_MSG_IDX2 
    ON @SCHEMA@.BPM_ASSET_CACHE_EVENT_MSG(
    "CACHED_ON")
    USING STOGROUP @STOGRP@

;

CREATE TABLESPACE WLPZ8501
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.BPM_CASE_PROPERTY (
    "PROP_ID" CHAR(36) NOT NULL,
    "SYMBOLIC_NAME" VARCHAR(128) NOT NULL,
    "SNAPSHOT_ID" CHAR(36),
    "BRANCH_ID" CHAR(36) NOT NULL,
    "PROJECT_ID" CHAR(36) NOT NULL,
    "IS_TIP" CHAR(1),
    "REF_PO_INTERNAL_NAME" VARCHAR(112) NOT NULL,
    "REF_PO_TYPE" DECIMAL(2,0) NOT NULL
)
IN @DB_NAME@.WLPZ8501
;


CREATE UNIQUE INDEX @SCHEMA@.BPM_CASEPROP_PK
    ON @SCHEMA@.BPM_CASE_PROPERTY
    ("PROP_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.BPM_CASE_PROPERTY
    ADD CONSTRAINT BPM_CASEPROP_PK
    PRIMARY KEY(
       "PROP_ID")

;

CREATE INDEX @SCHEMA@.BPM_IDX_CASEPROP 
    ON @SCHEMA@.BPM_CASE_PROPERTY(
    "PROJECT_ID")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_IDX2_CASEPROP 
    ON @SCHEMA@.BPM_CASE_PROPERTY(
    "BRANCH_ID",
    "IS_TIP")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_IDX3_CASEPROP 
    ON @SCHEMA@.BPM_CASE_PROPERTY(
    "SNAPSHOT_ID")
    USING STOGROUP @STOGRP@

;

ALTER  TABLE @SCHEMA@.LSW_CLASS 
ADD 
    "INTERNAL_NAME" VARCHAR(200)
;

ALTER  TABLE @SCHEMA@.LSW_CLASS 
ADD 
    "EXTENSION_TYPE" DECIMAL(2,0)
;



CREATE INDEX @SCHEMA@.LSW_IDX3_CLASS 
    ON @SCHEMA@.LSW_CLASS(
    "VERSION_ID",
    "EXTENSION_TYPE")
    USING STOGROUP @STOGRP@

;

ALTER  TABLE @SCHEMA@.LSW_BPD_INSTANCE 
ADD 
    "STARTER_ID" DECIMAL(12,0)
;


ALTER  TABLE @SCHEMA@.LSW_TASK_NARR 
ADD 
    "I18N_NARRATIVES" BLOB(2G)
;

CREATE LOB TABLESPACE WLP456
   IN @DB_NAME@ USING STOGROUP @STOGRP@
   BUFFERPOOL @BPLOB4K@
;
CREATE AUX TABLE @SCHEMA@.LSW_TASK_NARR6_LOB
    IN @DB_NAME@.WLP456
    STORES @SCHEMA@.LSW_TASK_NARR COLUMN I18N_NARRATIVES
;
CREATE UNIQUE INDEX @SCHEMA@.LSW_TASK_NARR6_I
    ON @SCHEMA@.LSW_TASK_NARR6_LOB
    USING STOGROUP @STOGRP@
;
        

CREATE TABLESPACE WLPZ301
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE4K@    
;
CREATE TABLE @SCHEMA@.BPM_BPD_RESOURCE_LINK (
    "BPD_RESOURCE_LINK_ID" CHAR(36) NOT NULL,
    "RESOURCE_BUNDLE_GROUP_ID" CHAR(36) NOT NULL,
    "BPD_ID" CHAR(36) NOT NULL,
    "GUID" VARCHAR(256) NOT NULL,
    "VERSION_ID" CHAR(36) NOT NULL,
    "LAST_MODIFIED" TIMESTAMP NOT NULL,
    "LAST_MODIFIED_BY_USER_ID" DECIMAL(12,0) NOT NULL
)
IN @DB_NAME@.WLPZ301
;


CREATE UNIQUE INDEX @SCHEMA@.BPM_BPD_RES_LK_PK
    ON @SCHEMA@.BPM_BPD_RESOURCE_LINK
    ("VERSION_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.BPM_BPD_RESOURCE_LINK
    ADD CONSTRAINT BPM_BPD_RES_LK_PK
    PRIMARY KEY(
       "VERSION_ID")

;

CREATE INDEX @SCHEMA@.BPM_BPD_RES_LK_PK3
    ON @SCHEMA@.BPM_BPD_RESOURCE_LINK("GUID")
    USING STOGROUP @STOGRP@

;

DROP INDEX @SCHEMA@.BPM_TASK_INDEX_IDX
                
;



CREATE INDEX @SCHEMA@.BPM_TASK_INDEX_IDX 
    ON @SCHEMA@.BPM_TASK_INDEX(
    "MAJOR_EVENT_DATETIME",
    "TASK_ID",
    "INSTANCE_ID")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_TASK_INDEX_IDX2 
    ON @SCHEMA@.BPM_TASK_INDEX(
    "INSTANCE_ID",
    "MAJOR_EVENT_DATETIME")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.BPM_INSTANCE_INDEX_IDX2 
    ON @SCHEMA@.BPM_INSTANCE_INDEX(
    "INSTANCE_ID",
    "MAJOR_EVENT_DATETIME")
    USING STOGROUP @STOGRP@

;


CREATE INDEX @SCHEMA@.LSWC_FAV_NUQ3 
    ON @SCHEMA@.LSW_FAVORITE(
    "ITEM_TYPE",
    "ITEM_ID")
    USING STOGROUP @STOGRP@

;

					UPDATE @SCHEMA@.BPM_GOVERNANCE_EVENT SET GOV_DEFAULT_SNAPSHOT_ID='5c679113-27ac-4bb8-bc83-36a0909c38e6' WHERE EVENT_TYPE_ID='dbecd816-afed-47b0-ba92-c13256fcb568';
					UPDATE @SCHEMA@.BPM_GOVERNANCE_EVENT SET GOV_DEFAULT_SNAPSHOT_ID='5c679113-27ac-4bb8-bc83-36a0909c38e6' WHERE EVENT_TYPE_ID='dbecd816-afed-47b0-ba92-c13256fcb569';
				
DROP INDEX @SCHEMA@.IDX_BRANCH
                
;


CREATE INDEX @SCHEMA@.IDX_BRANCH 
    ON @SCHEMA@.LSW_BRANCH(
    "PROJECT_ID",
    "LAST_MODIFIED")
    USING STOGROUP @STOGRP@

;

;

;



ALTER  TABLE @SCHEMA@.BPM_COACH_VIEW 
ADD 
    "ENABLE_DEV_MODE" CHAR(1)
        DEFAULT 'F'
;


					INSERT INTO @SCHEMA@.LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
					  VALUES(23, 3, 2066, '56a4e5e8-4da1-429c-8d9b-b5be67e881d2', 127)
					;
					INSERT INTO @SCHEMA@.LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
					  VALUES(24, 4, 2066, '56a4e5e8-4da1-429c-8d9b-b5be67e881d2', 63)
					;
				
CREATE TABLESPACE WLPZ8105
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  LOCKMAX SYSTEM
  LOCKSIZE ROW
  DEFINE YES
  CCSID UNICODE
  BUFFERPOOL @BPTABLE8K@
;
CREATE TABLE @SCHEMA@.LSW_SAP_CONNECTION (
    "SAP_CONNECTION_ID" CHAR(36) NOT NULL,
    "CREATED_BY_USER_ID" DECIMAL(12,0) NOT NULL,
    "CREATED_ON" TIMESTAMP NOT NULL,
    "MODIFIED_ON" TIMESTAMP,
    "IS_DEFAULT" CHAR(1)
        DEFAULT 'F' NOT NULL,
    "SYSNAME" VARCHAR(800) NOT NULL,
    "SAPUID" VARCHAR(800) NOT NULL,
    "PASSWORD" VARCHAR(800) NOT NULL,
    "CLIENT" VARCHAR(800) NOT NULL,
    "PORT" VARCHAR(800) NOT NULL,
    "LOCATION" VARCHAR(800) NOT NULL,
    "PROTOCAL" VARCHAR(800),
    "WEBSERVICE_PATTERN" VARCHAR(800)
)
IN @DB_NAME@.WLPZ8105
;


CREATE UNIQUE INDEX @SCHEMA@.LSWC_SAP_CONNECTION_PK
    ON @SCHEMA@.LSW_SAP_CONNECTION
    ("SAP_CONNECTION_ID")
    USING STOGROUP @STOGRP@

;

ALTER TABLE @SCHEMA@.LSW_SAP_CONNECTION
    ADD CONSTRAINT LSWC_SAP_CONNECTION_PK
    PRIMARY KEY(
       "SAP_CONNECTION_ID")

;

CREATE UNIQUE INDEX @SCHEMA@.LSWC_SAP_CONNECTION_UQ
    ON @SCHEMA@.LSW_SAP_CONNECTION(
        "SYSNAME",
        "CREATED_BY_USER_ID")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.LSW_SAP_CONNECTION_IDX1 
    ON @SCHEMA@.LSW_SAP_CONNECTION(
    "MODIFIED_ON")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.LSW_SAP_CONNECTION_IDX2 
    ON @SCHEMA@.LSW_SAP_CONNECTION(
    "CREATED_ON")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.LSW_SAP_CONNECTION_IDX3 
    ON @SCHEMA@.LSW_SAP_CONNECTION(
    "SYSNAME")
    USING STOGROUP @STOGRP@

;

CREATE INDEX @SCHEMA@.LSW_SAP_CONNECTION_IDX4 
    ON @SCHEMA@.LSW_SAP_CONNECTION(
    "IS_DEFAULT")
    USING STOGROUP @STOGRP@

;



                            DROP PROCEDURE @SCHEMA@.LSW_HOUSE_KEEPING@
                        
CREATE PROCEDURE @SCHEMA@.LSW_HOUSE_KEEPING(IN modeHK DECIMAL(12,0))
    LANGUAGE SQL

MAIN:
BEGIN

DECLARE statuses VARCHAR(64);
DECLARE sqlCmd VARCHAR(4000);
DECLARE flgStatusNotExist CHAR(1);
DECLARE flgDelete CHAR(1);
DECLARE rootTaskId DECIMAL(12,0);
DECLARE taskId DECIMAL(12,0);
DECLARE taskStatus VARCHAR(2);

DECLARE at_end DECIMAL(1,0);
DECLARE not_found CONDITION for SQLSTATE '02000';
DECLARE CONTINUE HANDLER for not_found SET at_end = 1;

IF (modeHK = 1) THEN

  -- Delete orphaned and DELETED task attachments
  DELETE FROM @SCHEMA@.LSW_TASK_FILE
   WHERE TASK_ID IN
     (SELECT TASK_ID
        FROM @SCHEMA@.LSW_TASK WHERE STATUS IN ('91','92'));

  DELETE FROM @SCHEMA@.LSW_FILE
   WHERE FILE_ID NOT IN
     (SELECT FILE_ID FROM @SCHEMA@.LSW_TASK_FILE)
    OR FILE_ID NOT IN
     (SELECT FILE_ID FROM @SCHEMA@.LSW_TASK,@SCHEMA@.LSW_TASK_FILE
       WHERE @SCHEMA@.LSW_TASK.TASK_ID = @SCHEMA@.LSW_TASK_FILE.TASK_ID);

  DELETE FROM @SCHEMA@.LSW_TASK_FILE
   WHERE FILE_ID NOT IN
     (SELECT FILE_ID FROM @SCHEMA@.LSW_FILE)
    OR TASK_ID NOT IN
     (SELECT @SCHEMA@.LSW_TASK.TASK_ID FROM @SCHEMA@.LSW_TASK,@SCHEMA@.LSW_TASK_FILE
   WHERE @SCHEMA@.LSW_TASK.TASK_ID = @SCHEMA@.LSW_TASK_FILE.TASK_ID);

  -- Delete orphaned task-scoped temporary groups
  CALL @SCHEMA@.LSW_ERASE_TEMP_GROUPS();

ELSEIF (modeHK > 1) THEN

  -- Define what task statuses we are interested in
  SET statuses = '';
  IF (modeHK >= 2) THEN
    SET statuses = '''91'',''92''';
  END IF;
  IF (modeHK >= 3) THEN
    SET statuses = statuses || ',''21''';
  END IF;
  IF (modeHK >= 4) THEN
    SET statuses = statuses || ',''31'',''32''';
  END IF;

  -- This is the only difference from DB2
  -- multiplatform: DB2 Z does not (as of v10)
  -- support the NOT LOGGED WITH REPLACE syntax.
  --
  -- I don't believe that we are relying on either
  -- one of those.
  DECLARE GLOBAL TEMPORARY TABLE TEMP_DELETE_TASK (
  TASK_ID DECIMAL(12,0) NOT NULL
  );

  BEGIN
  -- Go through each root task id --
  DECLARE curAllRootTasks CURSOR FOR stmt1;
  SET sqlCmd = 'SELECT DISTINCT ORIG_TASK_ID FROM @SCHEMA@.LSW_TASK';
  PREPARE stmt1 FROM sqlCmd;
  OPEN curAllRootTasks;
  MAIN_LOOP:
  LOOP
    SET at_end = 0;
    FETCH curAllRootTasks INTO rootTaskId;
    IF (at_end = 1) THEN
      LEAVE MAIN_LOOP;
    END IF;

    -- Check each task belonging to the current root task group.
    -- If ALL tasks in this group belong to the statuses we are
    -- interested in, then we can remove these tasks
    SET flgDelete = 'T';
    BEGIN
    DECLARE curRootTask CURSOR FOR stmt2;
    SET sqlCmd = 'SELECT TASK_ID, STATUS ' ||
                 'FROM @SCHEMA@.LSW_TASK WHERE ORIG_TASK_ID = ?';
    PREPARE stmt2 FROM sqlCmd;
    OPEN curRootTask USING rootTaskId;
    ROOT_TASK_LOOP:
    LOOP
      SET at_end = 0;
      FETCH curRootTask INTO taskId, taskStatus;
      IF (at_end = 1) THEN
        LEAVE ROOT_TASK_LOOP;
      END IF;

      SET flgStatusNotExist = 'F';
      BEGIN
      DECLARE curStatusNotExist CURSOR FOR stmt3;
      SET sqlCmd = 'SELECT ''T'' FROM SYSIBM.SYSDUMMY1 ' ||
                    'WHERE ? NOT IN (' || statuses || ')';
      PREPARE stmt3 FROM sqlCmd;
      OPEN curStatusNotExist USING taskStatus;
      FETCH curStatusNotExist INTO flgStatusNotExist;
      CLOSE curStatusNotExist;
      END;

      IF (flgStatusNotExist = 'T') THEN
        SET flgDelete = 'F';
        LEAVE ROOT_TASK_LOOP;
      END IF;

      INSERT INTO SESSION.TEMP_DELETE_TASK VALUES (taskId);

    END LOOP;

    CLOSE curRootTask;

    IF (flgDelete = 'T') THEN
      BEGIN
      DECLARE curDeleteTask CURSOR FOR stmt4;
      SET sqlCmd = 'SELECT TASK_ID FROM SESSION.TEMP_DELETE_TASK';
      PREPARE stmt4 FROM sqlCmd;
      OPEN curDeleteTask;
      SET at_end = 0;
      DELETE_TASK_LOOP:
      LOOP
        SET at_end = 0;
        FETCH curDeleteTask INTO taskId;
        IF (at_end = 1) THEN
          LEAVE DELETE_TASK_LOOP;
        END IF;
    DELETE FROM @SCHEMA@.LSW_TASK_NARR WHERE TASK_ID = taskId;
    DELETE FROM @SCHEMA@.LSW_TASK_FILE WHERE TASK_ID = taskId;
    DELETE FROM @SCHEMA@.LSW_TASK_ADDR WHERE TASK_ID = taskId;
    DELETE FROM @SCHEMA@.LSW_TASK_EXECUTION_CONTEXT WHERE TASK_ID = taskId;
    DELETE FROM @SCHEMA@.LSW_TASK WHERE TASK_ID = taskId;
      END LOOP;
      CLOSE curDeleteTask;
      END;
    END IF;

    DELETE FROM SESSION.TEMP_DELETE_TASK;

    END;

  END LOOP;

  CLOSE curAllRootTasks;

  END;

  DROP TABLE SESSION.TEMP_DELETE_TASK;

  -- Delete all attachment files that are not
  -- referenced by any task
  DELETE FROM @SCHEMA@.LSW_FILE
   WHERE FILE_ID NOT IN (SELECT FILE_ID FROM @SCHEMA@.LSW_TASK_FILE);

  -- Delete orphaned task-scoped temporary groups
  CALL @SCHEMA@.LSW_ERASE_TEMP_GROUPS();

END IF;

END@



                        





      
-- END of phase ProcUpgradeTo855 --
        
    